// 	LISTA SIMPLEMENTE VINCULADA en POO

#include <iostream.h>
#include <stdlib.h>

class Nodo {
private:
	int info;
	Nodo *prox;
public:
	Nodo(int x=0,Nodo *p=NULL) {info=x; prox=p;} //  Constructor
	int   getInfo()       {return info;} 			//  Obtenemos info
	Nodo *getProx()       {return prox;}      	//  Obtenemos prox
	void  setInfo(int x)  {info=x;}         		//  Asignamos info
	void  setProx(Nodo *p){prox=p;}          		//  Asignamos prox
};

class Lista  {
private:
	Nodo *raiz,*q;
	int  vacia(){return raiz == 0 ? 1 : 0;}
public:
	Lista (){raiz=q=0;}   				   			//  Constructor
	~Lista();												//  Destructor
	void insUltimo (int x);							  	//  Al fondo
	void insPrimero(int x); 							//  Al principio
	Nodo *loBorramos(int x);							//  Excluir nodo
	Nodo *loEncuentro (int x);							//  Busqueda
	void imprimir();
};

//  Definiciones de comportamiento de la clase Lista

Lista::~Lista() {
	Nodo *p=raiz;
	while (p){
		raiz=p;
		p=p->getProx();
		delete raiz;
	}
	raiz=0;
};

void Lista::insPrimero(int x) {
	Nodo *p;
	p = new Nodo(x,raiz);       //  Insertamos ...
	raiz = p;                   //  Redireccionamos raiz ...
};

void Lista::insUltimo(int x) {
	if (vacia()){
		raiz = new Nodo(x);
	}
	else {
		Nodo *p;
		for(p=raiz;p;q=p,p=p->getProx());
		q->setProx(new Nodo(x));
	}
};

Nodo* Lista::loBorramos(int x) {
	Nodo *p=loEncuentro(x);
	if (p) {
			q->setProx (p->getProx()); //  "Bypass" al nodo p ...
		delete p;
		return q;
	}    //  y lo borramos ...
	else
		return NULL;
};

Nodo* Lista::loEncuentro(int x) {
	for(Nodo *p=raiz; p && p->getInfo()!= x; q=p,p=p->getProx());
		return p !=  NULL ? p : NULL;
};

void Lista::imprimir(){
	for(Nodo *p=raiz;p;p=p->getProx())
		cout <<p->getInfo()<<",  ";
	cout <<" \n";
};

void main(void) {
	int frente[]={1,2,3};
	int fondon[]={7,8,9};
	int i;
	Lista list;   //  Objeto list c/atributo raiz inicilizado a 0
	cout <<"El mismo tema de listas, usando clases \n";
	cout <<"====================================== \n\n";
	for(i=0;i< sizeof(frente)/2;i++)
		list.insPrimero(frente[i]);
	cout <<"Lista con {frente} \n";
	list.imprimir();
	for(i=0;i< sizeof(fondon)/2;i++)
		list.insUltimo(fondon[i]);
	cout <<"Lista con {frente} y {fondon} \n";
	list.imprimir();
	if(list.loBorramos(7)){
		cout<<"loBorramos(7), Lista queda: \n";
		list.imprimir();
	}
	else{
		cout<<"no loBorramos(7), lista queda: \n";
		list.imprimir();
	}
	cout <<"Terminamos ... \n";
	exit(1);
}
